<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: DayzExpansion/BaseBuilding/Scripts/4_world/dayzexpansion_basebuilding/entities/items/expansioncodelock.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.12</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d6/d1d/expansioncodelock_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">expansioncodelock.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d6/d1d/expansioncodelock_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * ExpansionCodeLock.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * DayZ Expansion Mod</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * www.dayzexpansion.com</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * © 2022 DayZ Expansion Mod Team</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License. </span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-nd/4.0/.</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment"></span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="../../d0/deb/namespace_3global_scope_4.html">   13</a></span><span class="comment">/**@class       ExpansionCodeLock</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment"> * @brief       </span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="comment"> **/</span></div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="keyword">class </span><a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#d1/d4a/class_expansion_code_lock">ExpansionCodeLock</a> <span class="keyword">extends</span> <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>{</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a9f2b57af4182b1f691b8a1876ec5fca7">   18</a></span>    <span class="keyword">static</span> <span class="keyword">protected</span> <span class="keyword">const</span> <span class="keywordtype">string</span> RED_LIGHT_GLOW    = <span class="stringliteral">&quot;dz\\gear\\camping\\data\\battery_charger_light_r.rvmat&quot;</span>;</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#afe818bbab0e1dc09ae3c27ff9bb0a855">   19</a></span>    <span class="keyword">static</span> <span class="keyword">protected</span> <span class="keyword">const</span> <span class="keywordtype">string</span> GREEN_LIGHT_GLOW  = <span class="stringliteral">&quot;dz\\gear\\camping\\data\\battery_charger_light_g.rvmat&quot;</span>;</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a3bc01dffadf8d9d69073558f3a6f99db">   20</a></span>    <span class="keyword">static</span> <span class="keyword">protected</span> <span class="keyword">const</span> <span class="keywordtype">string</span> DEFAULT_MATERIAL  = <span class="stringliteral">&quot;DayZExpansion\\Objects\\Basebuilding\\Items\\Codelock\\data\\codelock.rvmat&quot;</span>;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a1ce06e776a5ae51952741db6fa11d1e5">   22</a></span>    <span class="keyword">protected</span> <span class="keyword">static</span> ref TStringArray s_Expansion_InventorySlots = <span class="keyword">new</span> TStringArray;</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>    <span class="keyword">protected</span> EffectSound m_Sound;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>    </div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a52871227a3a4141e039f275bcdf11fbc">   26</a></span>    <span class="keyword">protected</span> <span class="keywordtype">bool</span> <a class="code hl_variable" href="../../de/d7a/class_item_base.html#a52871227a3a4141e039f275bcdf11fbc">m_WasSynced</a>;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a57416c510e6f0b41c3332626672ed244">   27</a></span>    <span class="keyword">protected</span> <span class="keywordtype">bool</span> <a class="code hl_variable" href="../../de/d7a/class_item_base.html#a57416c510e6f0b41c3332626672ed244">m_WasLocked</a>;</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a9939ba1576a01c48c4411fa06da78a6b">   29</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a9939ba1576a01c48c4411fa06da78a6b">ExpansionCodeLock</a>()</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>    {</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>        m_KnownUIDs = <span class="keyword">new</span> TStringArray;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>        RegisterNetSyncVariableBool( <span class="stringliteral">&quot;m_Locked&quot;</span> );</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>        RegisterNetSyncVariableInt( <span class="stringliteral">&quot;m_CodeLength&quot;</span> );</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    }</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span> </div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#aac771abcee14bf403cf6643d33e8e926">   37</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#aac771abcee14bf403cf6643d33e8e926">DeferredInit</a>()</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>    {</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        super.DeferredInit();</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>        UpdateVisuals();</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span> </div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>        <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> parent = <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a>.Cast( GetHierarchyParent() );</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>        <span class="keywordflow">if</span> ( parent &amp;&amp; parent.<a class="code hl_function" href="../../de/d7a/class_item_base.html#a52676972f5793354072ffb09ca20da09">ExpansionGetCodeLock</a>() == <span class="keyword">this</span> )</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>        {</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>            <span class="keywordflow">if</span> ( GetGame().IsServer() &amp;&amp; !HasCode() &amp;&amp; parent.<a class="code hl_function" href="../../de/d7a/class_item_base.html#ab2db4aed076d5ad2f5199aa498b7060e">HasCode</a>() )</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>            {</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>                EXPrint(ToString() + <span class="stringliteral">&quot;::DeferredInit - migrating code from &quot;</span> + parent.ToString() + <span class="stringliteral">&quot; &quot;</span> + parent.GetPosition());</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span><span class="comment"></span> </div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span><span class="comment">                //! Migrate code</span></div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span><span class="comment"></span>                SetCode(parent.<a class="code hl_function" href="../../de/d7a/class_item_base.html#aba586066d2660a4b12e816bc39008252">GetCode</a>(), NULL, <span class="keyword">false</span>, <span class="keyword">false</span>);</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span><span class="comment"></span> </div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span><span class="comment">                //! Migrate locked state</span></div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span><span class="comment"></span>                <span class="keywordflow">if</span> (parent.<a class="code hl_function" href="../../de/d7a/class_item_base.html#a1b94569f63e51cbb3f67ba452b98066d">ExpansionIsLocked</a>())</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>                    ExpansionLock();</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>                parent.<a class="code hl_function" href="../../de/d7a/class_item_base.html#aa766b041d57592d506fa2c0da0dbda14">SetCode</a>(<span class="stringliteral">&quot;&quot;</span>, NULL, <span class="keyword">true</span>, <span class="keyword">false</span>);</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>            }</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>            <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( ExpansionIsLocked() )</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>            {</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>                SetSlotLock( parent, <span class="keyword">true</span> );</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>                SetTakeable( <span class="keyword">false</span> );</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>            }</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        }</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>        <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( GetGame().IsServer() &amp;&amp; HasCode() )</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>        {</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>            EXPrint(ToString() + <span class="stringliteral">&quot;::DeferredInit - removing code from unattached &quot;</span> + ToString() + <span class="stringliteral">&quot; &quot;</span> + <a class="code hl_function" href="../../d5/dc8/expansionterritory_8c.html#a68c83d319275347dcd1c0c4da8734703">GetPosition</a>());</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>            SetCode(<span class="stringliteral">&quot;&quot;</span>);</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>        }</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>    }</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span> </div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span><span class="preprocessor">    #ifdef EXPANSION_MODSTORAGE</span></div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>    <span class="keyword">override</span> <span class="keywordtype">void</span> CF_OnStoreSave(CF_ModStorageMap storage)</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>    {</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>        super.CF_OnStoreSave(storage);</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span> </div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>        <span class="keyword">auto</span> ctx = storage[DZ_Expansion_BaseBuilding];</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        <span class="keywordflow">if</span> (!ctx) <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>        ctx.Write( m_Locked );</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>        ctx.Write( m_Code );</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span> </div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>        ctx.Write( m_KnownUIDs.Count() );</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        <span class="keywordflow">for</span> ( <span class="keywordtype">int</span> i = 0; i &lt; m_KnownUIDs.Count(); i++ )</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>        {</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>            ctx.Write( m_KnownUIDs[i] );</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>        }</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>    }</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>    </div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> CF_OnStoreLoad(CF_ModStorageMap storage)</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>    {</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        <span class="keywordflow">if</span> (!super.CF_OnStoreLoad(storage))</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span> </div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        <span class="keyword">auto</span> ctx = storage[DZ_Expansion_BaseBuilding];</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>        <span class="keywordflow">if</span> (!ctx) <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>        <span class="keywordflow">if</span> ( ctx.GetVersion() &gt;= 38 )</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>        {</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>            <span class="keywordflow">if</span> ( Expansion_Assert_False( ctx.Read( m_Locked ), <span class="stringliteral">&quot;[&quot;</span> + <span class="keyword">this</span> + <span class="stringliteral">&quot;] Failed reading m_Locked&quot;</span> ) )</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>            <span class="keywordflow">if</span> ( Expansion_Assert_False( ctx.Read( m_Code ), <span class="stringliteral">&quot;[&quot;</span> + <span class="keyword">this</span> + <span class="stringliteral">&quot;] Failed reading m_Code&quot;</span> ) )</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span> </div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>            m_CodeLength = m_Code.Length();</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        }</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span> </div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        <span class="keywordtype">int</span> count;</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        <span class="keywordflow">if</span> (!ctx.Read(count))</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; count; i++)</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>        {</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>            <span class="keywordtype">string</span> knownUID;</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>            <span class="keywordflow">if</span> (!ctx.Read(knownUID))</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span> </div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>            m_KnownUIDs.Insert( knownUID );</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>        }</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span> </div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>    }</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span><span class="preprocessor">    #endif</span></div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span> </div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a45bcceec0acd0ccdc9d6afd42d4e839a">  125</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a45bcceec0acd0ccdc9d6afd42d4e839a">SetActions</a>()</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    {</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>        super.SetActions();</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>        </div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>        AddAction( <a class="code hl_class" href="../../d0/da3/class_expansion_action_attach_code_lock.html">ExpansionActionAttachCodeLock</a> );</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        <span class="comment">//AddAction( ExpansionActionEnterCodeLock );</span></div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>        <span class="comment">//AddAction( ExpansionActionChangeCodeLock );</span></div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>    }</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>    </div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a8e5514abc697470b14e82092d358a01a">  134</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a8e5514abc697470b14e82092d358a01a">CanDetachAttachment</a>(EntityAI parent)</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>    {</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>        <span class="keywordflow">if</span> ( !super.CanDetachAttachment( parent ) )</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>        {</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>        }</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>        </div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>        <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> target = <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a>.Cast( parent );</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span> </div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        <span class="keywordflow">if</span> ( target &amp;&amp; target.<a class="code hl_function" href="../../de/d7a/class_item_base.html#a1b94569f63e51cbb3f67ba452b98066d">ExpansionIsLocked</a>() )</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>        {</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>        }</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>        </div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>    }</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span> </div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#ab25ae69addd27f6c73194dd9cae125fa">  151</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#ab25ae69addd27f6c73194dd9cae125fa">OnWasAttached</a>( EntityAI parent, <span class="keywordtype">int</span> slot_id )</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>    {</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>        super.OnWasAttached( parent, slot_id );</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span> </div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>        UpdateVisuals();</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>    }</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span> </div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a275b23ae34e1bf9eec6dca0968556e6f">  158</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a275b23ae34e1bf9eec6dca0968556e6f">OnWasDetached</a>( EntityAI parent, <span class="keywordtype">int</span> slot_id )</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>    {</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>        super.OnWasDetached( parent, slot_id );</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span> </div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>        UpdateVisuals();</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span> </div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>        <span class="keywordflow">if</span> (GetGame().IsServer())</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>            SetCode(<span class="stringliteral">&quot;&quot;</span>);</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>    }</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span> </div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a3fdf84d979febb271546faad12b4db26">  168</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a3fdf84d979febb271546faad12b4db26">UnlockServer</a>( EntityAI player, EntityAI parent )</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>    {</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>        <span class="keywordflow">if</span> ( parent &amp;&amp; GetInventory().IsAttachment() )</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        {</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>            ExpansionUnlock();</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>            <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> item;</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>            <span class="keywordflow">if</span> (parent.GetInventory() &amp;&amp; parent.GetInventory().IsInventoryLocked() &amp;&amp; Class.CastTo(item, parent) &amp;&amp; !item.<a class="code hl_function" href="../../de/d7a/class_item_base.html#a8904ed66094596846fc2bdcb3a5a581e">IsOpen</a>())</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>                item.<a class="code hl_function" href="../../de/d7a/class_item_base.html#a82f9866c70e714a96f0b31e3133d6f59">Open</a>();</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>            ExpansionDropServer( <a class="code hl_class" href="../../d5/da8/class_player_base.html">PlayerBase</a>.Cast( player ) );</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>        }</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>    }</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span> </div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a8850a7a5bf95dc0aeefab30a4d762886">  180</a></span>    <span class="keyword">override</span> <span class="keyword">protected</span> <span class="keywordtype">string</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a8850a7a5bf95dc0aeefab30a4d762886">GetDestroySound</a>()</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>    {</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>        <span class="keywordflow">return</span> <span class="stringliteral">&quot;combinationlock_open_SoundSet&quot;</span>;</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>    }</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span> </div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a23257b790ec37848886f7ae726aad8af">  185</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a23257b790ec37848886f7ae726aad8af">ExpansionOnDestroyed</a>( Object killer )</div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>    {</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>        <span class="keywordflow">if</span> ( IsDamageDestroyed() )</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span> </div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>        SetHealth( 0 );</div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>        UnlockServer( EntityAI.Cast( killer ), GetHierarchyParent() );</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>    }</div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>        </div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#ac2f2a2f2b046119a848ac043716b440d">  194</a></span>    <span class="keyword">static</span> TStringArray <a class="code hl_function" href="../../de/d7a/class_item_base.html#ac2f2a2f2b046119a848ac043716b440d">Expansion_GetInventorySlots</a>()</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>    {</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>        <span class="keywordflow">if</span> (!s_Expansion_InventorySlots.Count())</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>            GetGame().ConfigGetTextArray(<span class="stringliteral">&quot;CfgVehicles ExpansionCodeLock inventorySlot&quot;</span>, s_Expansion_InventorySlots);</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span> </div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>        <span class="keywordflow">return</span> s_Expansion_InventorySlots;</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>    }</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span> </div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#aa5c630f3e789c5bf07b46ce04e859546">  202</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#aa5c630f3e789c5bf07b46ce04e859546">OnVariablesSynchronized</a>()</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>    {</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>        super.OnVariablesSynchronized();</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span> </div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>        <span class="keywordflow">if</span> ( m_WasSynced &amp;&amp; m_WasLocked != m_Locked )</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>        {</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>            <span class="keywordflow">if</span> ( m_Locked )</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>                SoundCodeLockLocked();</div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>            <span class="keywordflow">else</span></div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>                SoundCodeLockUnlocked();</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>        }</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span> </div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>        m_WasLocked = m_Locked;</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>        m_WasSynced = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span> </div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>        UpdateVisuals();</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>    }</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span> </div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>    <span class="comment">// --- VISUALS</span></div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a168f6c400289a40423bbefa2a63d3cbb">  221</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a168f6c400289a40423bbefa2a63d3cbb">UpdateVisuals</a>()</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>    {</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>        <span class="comment">//Client/Server</span></div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>        GetGame().GetCallQueue( CALL_CATEGORY_GAMEPLAY ).CallLater( UpdateVisuals_Deferred, 0, <span class="keyword">false</span> );</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>    }</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>    </div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a63f5c282b9c66fcd8eadf7ccb5726f7e">  227</a></span>    <span class="keyword">protected</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a63f5c282b9c66fcd8eadf7ccb5726f7e">UpdateVisuals_Deferred</a>()</div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>    {</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>        <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> parent = <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a>.Cast( GetHierarchyParent() );</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span> </div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>        <span class="keywordflow">if</span> ( parent &amp;&amp; parent.IsInherited( <a class="code hl_class" href="../../dd/d90/class_base_building_base.html">BaseBuildingBase</a> ) &amp;&amp; !parent.IsInherited( <a class="code hl_class" href="../../d3/d50/class_expansion_base_building.html">ExpansionBaseBuilding</a> ) )</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>        {</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>            HideSelection( <span class="stringliteral">&quot;camo&quot;</span> );</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>            HideSelection( <span class="stringliteral">&quot;Codelock&quot;</span> );</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>            ShowSelection( <span class="stringliteral">&quot;attach_fence&quot;</span> );</div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span>        } <span class="keywordflow">else</span></div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>        {</div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>            ShowSelection( <span class="stringliteral">&quot;camo&quot;</span> );</div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>            ShowSelection( <span class="stringliteral">&quot;Codelock&quot;</span> );</div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span>            HideSelection( <span class="stringliteral">&quot;attach_fence&quot;</span> );</div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>        }</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span> </div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>        <span class="keywordflow">if</span> ( !IsMissionClient() )</div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span> </div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>        <span class="keywordflow">if</span> ( parent &amp;&amp; ExpansionIsLocked() )</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span>        {</div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>            SetObjectMaterial( 0, DEFAULT_MATERIAL );</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>            SetObjectMaterial( 1, GREEN_LIGHT_GLOW );</div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>            SetObjectMaterial( 2, DEFAULT_MATERIAL );</div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span>        } <span class="keywordflow">else</span></div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>        {</div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>            SetObjectMaterial( 0, RED_LIGHT_GLOW );</div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>            SetObjectMaterial( 1, DEFAULT_MATERIAL );</div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>            SetObjectMaterial( 2, DEFAULT_MATERIAL );</div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span>        }</div>
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>    }</div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span>    </div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a4b50cab5209002921cfbdb3753c6f6bf">  259</a></span>    <span class="keyword">protected</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a4b50cab5209002921cfbdb3753c6f6bf">SoundCodeLockLocked</a>()</div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>    {</div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>        <span class="keywordflow">if</span> ( !GetGame().IsMultiplayer() || GetGame().IsClient() )</div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>        {</div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>            m_Sound = SEffectManager.PlaySound(<span class="stringliteral">&quot;Expansion_CodeLock_Lock1_SoundSet&quot;</span>, <a class="code hl_function" href="../../d5/dc8/expansionterritory_8c.html#a68c83d319275347dcd1c0c4da8734703">GetPosition</a>());</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>            m_Sound.SetSoundAutodestroy( <span class="keyword">true</span> );</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>        }</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>    }</div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>    </div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno"><a class="line" href="../../de/d7a/class_item_base.html#a5a3d79640b2e3577b4b2c08ea579bbc0">  268</a></span>    <span class="keyword">protected</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/d7a/class_item_base.html#a5a3d79640b2e3577b4b2c08ea579bbc0">SoundCodeLockUnlocked</a>()</div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>    {</div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span>        <span class="keywordflow">if</span> ( !GetGame().IsMultiplayer() || GetGame().IsClient() ) <span class="comment">// client side</span></div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span>        {</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span>            m_Sound = SEffectManager.PlaySound(<span class="stringliteral">&quot;Expansion_CodeLock_Unlock1_SoundSet&quot;</span>, <a class="code hl_function" href="../../d5/dc8/expansionterritory_8c.html#a68c83d319275347dcd1c0c4da8734703">GetPosition</a>());</div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>            m_Sound.SetSoundAutodestroy( <span class="keyword">true</span> );</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>        }</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>    }</div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span>}</div>
<div class="ttc" id="aclass_base_building_base_html"><div class="ttname"><a href="../../dd/d90/class_base_building_base.html">BaseBuildingBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d1/d74/basebuildingbase_8c_source.html#l00013">basebuildingbase.c:14</a></div></div>
<div class="ttc" id="aclass_expansion_action_attach_code_lock_html"><div class="ttname"><a href="../../d0/da3/class_expansion_action_attach_code_lock.html">ExpansionActionAttachCodeLock</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d94/expansionactionattachcodelock_8c_source.html#l00013">expansionactionattachcodelock.c:14</a></div></div>
<div class="ttc" id="aclass_expansion_base_building_html"><div class="ttname"><a href="../../d3/d50/class_expansion_base_building.html">ExpansionBaseBuilding</a></div><div class="ttdoc">This class handle base class of expansion basebuilding</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d58/expansionbasebuilding_8c_source.html#l00016">expansionbasebuilding.c:17</a></div></div>
<div class="ttc" id="aclass_item_base_html"><div class="ttname"><a href="../../de/d7a/class_item_base.html">ItemBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d4/dbd/expansionbaselights_8c_source.html#l00001">expansionbaselights.c:2</a></div></div>
<div class="ttc" id="aclass_item_base_html_a168f6c400289a40423bbefa2a63d3cbb"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a168f6c400289a40423bbefa2a63d3cbb">ItemBase::UpdateVisuals</a></div><div class="ttdeci">void UpdateVisuals()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00221">expansioncodelock.c:221</a></div></div>
<div class="ttc" id="aclass_item_base_html_a1b94569f63e51cbb3f67ba452b98066d"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a1b94569f63e51cbb3f67ba452b98066d">ItemBase::ExpansionIsLocked</a></div><div class="ttdeci">override bool ExpansionIsLocked()</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d35/itembase_8c_source.html#l00499">itembase.c:499</a></div></div>
<div class="ttc" id="aclass_item_base_html_a23257b790ec37848886f7ae726aad8af"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a23257b790ec37848886f7ae726aad8af">ItemBase::ExpansionOnDestroyed</a></div><div class="ttdeci">override void ExpansionOnDestroyed(Object killer)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00185">expansioncodelock.c:185</a></div></div>
<div class="ttc" id="aclass_item_base_html_a275b23ae34e1bf9eec6dca0968556e6f"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a275b23ae34e1bf9eec6dca0968556e6f">ItemBase::OnWasDetached</a></div><div class="ttdeci">override void OnWasDetached(EntityAI parent, int slot_id)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00158">expansioncodelock.c:158</a></div></div>
<div class="ttc" id="aclass_item_base_html_a3fdf84d979febb271546faad12b4db26"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a3fdf84d979febb271546faad12b4db26">ItemBase::UnlockServer</a></div><div class="ttdeci">void UnlockServer(EntityAI player, EntityAI parent)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00168">expansioncodelock.c:168</a></div></div>
<div class="ttc" id="aclass_item_base_html_a45bcceec0acd0ccdc9d6afd42d4e839a"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a45bcceec0acd0ccdc9d6afd42d4e839a">ItemBase::SetActions</a></div><div class="ttdeci">override void SetActions()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00125">expansioncodelock.c:125</a></div></div>
<div class="ttc" id="aclass_item_base_html_a4b50cab5209002921cfbdb3753c6f6bf"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a4b50cab5209002921cfbdb3753c6f6bf">ItemBase::SoundCodeLockLocked</a></div><div class="ttdeci">protected void SoundCodeLockLocked()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00259">expansioncodelock.c:259</a></div></div>
<div class="ttc" id="aclass_item_base_html_a52676972f5793354072ffb09ca20da09"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a52676972f5793354072ffb09ca20da09">ItemBase::ExpansionGetCodeLock</a></div><div class="ttdeci">ExpansionCodeLock ExpansionGetCodeLock()</div><div class="ttdoc">Returning codelock entity.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d35/itembase_8c_source.html#l00566">itembase.c:566</a></div></div>
<div class="ttc" id="aclass_item_base_html_a52871227a3a4141e039f275bcdf11fbc"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a52871227a3a4141e039f275bcdf11fbc">ItemBase::m_WasSynced</a></div><div class="ttdeci">protected bool m_WasSynced</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00026">expansioncodelock.c:26</a></div></div>
<div class="ttc" id="aclass_item_base_html_a57416c510e6f0b41c3332626672ed244"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a57416c510e6f0b41c3332626672ed244">ItemBase::m_WasLocked</a></div><div class="ttdeci">protected bool m_WasLocked</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00027">expansioncodelock.c:27</a></div></div>
<div class="ttc" id="aclass_item_base_html_a5a3d79640b2e3577b4b2c08ea579bbc0"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a5a3d79640b2e3577b4b2c08ea579bbc0">ItemBase::SoundCodeLockUnlocked</a></div><div class="ttdeci">protected void SoundCodeLockUnlocked()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00268">expansioncodelock.c:268</a></div></div>
<div class="ttc" id="aclass_item_base_html_a63f5c282b9c66fcd8eadf7ccb5726f7e"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a63f5c282b9c66fcd8eadf7ccb5726f7e">ItemBase::UpdateVisuals_Deferred</a></div><div class="ttdeci">protected void UpdateVisuals_Deferred()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00227">expansioncodelock.c:227</a></div></div>
<div class="ttc" id="aclass_item_base_html_a82f9866c70e714a96f0b31e3133d6f59"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a82f9866c70e714a96f0b31e3133d6f59">ItemBase::Open</a></div><div class="ttdeci">void Open(string selection)</div><div class="ttdoc">Opening item on defined selection.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d35/itembase_8c_source.html#l00353">itembase.c:353</a></div></div>
<div class="ttc" id="aclass_item_base_html_a8850a7a5bf95dc0aeefab30a4d762886"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a8850a7a5bf95dc0aeefab30a4d762886">ItemBase::GetDestroySound</a></div><div class="ttdeci">override protected string GetDestroySound()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00180">expansioncodelock.c:180</a></div></div>
<div class="ttc" id="aclass_item_base_html_a8904ed66094596846fc2bdcb3a5a581e"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a8904ed66094596846fc2bdcb3a5a581e">ItemBase::IsOpen</a></div><div class="ttdeci">override bool IsOpen()</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d35/itembase_8c_source.html#l00310">itembase.c:310</a></div></div>
<div class="ttc" id="aclass_item_base_html_a8e5514abc697470b14e82092d358a01a"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a8e5514abc697470b14e82092d358a01a">ItemBase::CanDetachAttachment</a></div><div class="ttdeci">override bool CanDetachAttachment(EntityAI parent)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00134">expansioncodelock.c:134</a></div></div>
<div class="ttc" id="aclass_item_base_html_a9939ba1576a01c48c4411fa06da78a6b"><div class="ttname"><a href="../../de/d7a/class_item_base.html#a9939ba1576a01c48c4411fa06da78a6b">ItemBase::ExpansionCodeLock</a></div><div class="ttdeci">void ExpansionCodeLock()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00029">expansioncodelock.c:29</a></div></div>
<div class="ttc" id="aclass_item_base_html_aa5c630f3e789c5bf07b46ce04e859546"><div class="ttname"><a href="../../de/d7a/class_item_base.html#aa5c630f3e789c5bf07b46ce04e859546">ItemBase::OnVariablesSynchronized</a></div><div class="ttdeci">override void OnVariablesSynchronized()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00202">expansioncodelock.c:202</a></div></div>
<div class="ttc" id="aclass_item_base_html_aa766b041d57592d506fa2c0da0dbda14"><div class="ttname"><a href="../../de/d7a/class_item_base.html#aa766b041d57592d506fa2c0da0dbda14">ItemBase::SetCode</a></div><div class="ttdeci">void SetCode(string code, PlayerBase player=NULL, bool setUser=true, bool updateLock=true)</div><div class="ttdoc">Set code of item.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d35/itembase_8c_source.html#l00413">itembase.c:413</a></div></div>
<div class="ttc" id="aclass_item_base_html_aac771abcee14bf403cf6643d33e8e926"><div class="ttname"><a href="../../de/d7a/class_item_base.html#aac771abcee14bf403cf6643d33e8e926">ItemBase::DeferredInit</a></div><div class="ttdeci">override void DeferredInit()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00037">expansioncodelock.c:37</a></div></div>
<div class="ttc" id="aclass_item_base_html_ab25ae69addd27f6c73194dd9cae125fa"><div class="ttname"><a href="../../de/d7a/class_item_base.html#ab25ae69addd27f6c73194dd9cae125fa">ItemBase::OnWasAttached</a></div><div class="ttdeci">override void OnWasAttached(EntityAI parent, int slot_id)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00151">expansioncodelock.c:151</a></div></div>
<div class="ttc" id="aclass_item_base_html_ab2db4aed076d5ad2f5199aa498b7060e"><div class="ttname"><a href="../../de/d7a/class_item_base.html#ab2db4aed076d5ad2f5199aa498b7060e">ItemBase::HasCode</a></div><div class="ttdeci">bool HasCode()</div><div class="ttdoc">Returning if the item has a code.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d35/itembase_8c_source.html#l00487">itembase.c:487</a></div></div>
<div class="ttc" id="aclass_item_base_html_aba586066d2660a4b12e816bc39008252"><div class="ttname"><a href="../../de/d7a/class_item_base.html#aba586066d2660a4b12e816bc39008252">ItemBase::GetCode</a></div><div class="ttdeci">string GetCode()</div><div class="ttdoc">Returning code of item.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d35/itembase_8c_source.html#l00454">itembase.c:454</a></div></div>
<div class="ttc" id="aclass_item_base_html_ac2f2a2f2b046119a848ac043716b440d"><div class="ttname"><a href="../../de/d7a/class_item_base.html#ac2f2a2f2b046119a848ac043716b440d">ItemBase::Expansion_GetInventorySlots</a></div><div class="ttdeci">static TStringArray Expansion_GetInventorySlots()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d1d/expansioncodelock_8c_source.html#l00194">expansioncodelock.c:194</a></div></div>
<div class="ttc" id="aclass_player_base_html"><div class="ttname"><a href="../../d5/da8/class_player_base.html">PlayerBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d4/dc0/playerbase_8c_source.html#l00013">playerbase.c:14</a></div></div>
<div class="ttc" id="aexpansionterritory_8c_html_a68c83d319275347dcd1c0c4da8734703"><div class="ttname"><a href="../../d5/dc8/expansionterritory_8c.html#a68c83d319275347dcd1c0c4da8734703">GetPosition</a></div><div class="ttdeci">vector GetPosition()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/dc8/expansionterritory_8c_source.html#l00293">expansionterritory.c:293</a></div></div>
<div class="ttc" id="anamespace_3global_scope_4_html_d1/d4a/class_expansion_code_lock"><div class="ttname"><a href="../../d0/deb/namespace_3global_scope_4.html#d1/d4a/class_expansion_code_lock">ExpansionCodeLock</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_6127fff2da0a20e2dc2cd9302c584350.html">DayzExpansion</a></li><li class="navelem"><a class="el" href="../../dir_e66306a3976d6d81f5e1305840c1314d.html">BaseBuilding</a></li><li class="navelem"><a class="el" href="../../dir_92106a510097343a3fe1c14124c59151.html">Scripts</a></li><li class="navelem"><a class="el" href="../../dir_844bf89108e22cf51aae4b5452c2c906.html">4_world</a></li><li class="navelem"><a class="el" href="../../dir_a0e24776517e17f620f1adfb86971bb4.html">dayzexpansion_basebuilding</a></li><li class="navelem"><a class="el" href="../../dir_4995a40041868e6722cdb7419e4f96ba.html">entities</a></li><li class="navelem"><a class="el" href="../../dir_71a03594abf1190ae146713f63fe5af1.html">items</a></li><li class="navelem"><a class="el" href="../../d6/d1d/expansioncodelock_8c.html">expansioncodelock.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
